/* This file has been put into the public domain by its author.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
   IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR
   OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
   ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
   OTHER DEALINGS IN THE SOFTWARE.
*/
/* dvc.c - Division of one complex number by another

   AUTHOR: Gregory Pietsch
   
*/

#include "fp.h"
#include "mpi.h"

_FP_T
_Dvc (_FP_T c, _FP_T a, _FP_T b, const _FP_METRIC_T *const m)
{
  unsigned char x[m->_Size << 1], t0[m->_Size], t1[m->_Size];

  _Mlf (t0, a, b, m);
  _Mlf (t1, a + m->_Size, b + m->_Size, m);
  _Adf (x, t0, t1, m);
  _Mlf (t0, a, b + m->_Size, m);
  _Mlf (t1, a + m->_Size, b, m);
  _Sbf (x + m->_Size, t1, t0, m);
  _Mlf (t0, b, b, m);
  _Mlf (t1, b + m->_Size, b + m->_Size, m);
  _Adf (t0, t0, t1, m);
  _Dvf (x, x, t0, m);
  _Dvf (x + m->_Size, x + m->_Size, t0, m);
  _Cpy (c, x, m->_Size << 1);
  return c;
}

/* END OF FILE */
